Package org.apache.lucene.codecs.lucene95

## Class OffHeapByteVectorValues.DenseOffHeapVectorValues

- java.lang.Object
- - org.apache.lucene.search.DocIdSetIterator
  - - org.apache.lucene.index.ByteVectorValues
    - - org.apache.lucene.codecs.lucene95.OffHeapByteVectorValues
      - - org.apache.lucene.codecs.lucene95.OffHeapByteVectorValues.DenseOffHeapVectorValues

- All Implemented Interfaces:
    `RandomAccessVectorValues<byte[]>`
  Enclosing class:
    OffHeapByteVectorValues

      public static class OffHeapByteVectorValues.DenseOffHeapVectorValues
      extends OffHeapByteVectorValues

  Dense vector values that are stored off-heap. This is the most common case when every doc has a vector.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.apache.lucene.codecs.lucene95.OffHeapByteVectorValues

      `OffHeapByteVectorValues.DenseOffHeapVectorValues`

  - ### Field Summary

    - ### Fields inherited from class org.apache.lucene.codecs.lucene95.OffHeapByteVectorValues

      `binaryValue, byteBuffer, byteSize, dimension, lastOrd, size, slice`

    - ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

      `NO_MORE_DOCS`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `DenseOffHeapVectorValues​(int dimension, int size, IndexInput slice, int byteSize)` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `advance​(int target)` | Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
    `RandomAccessVectorValues<byte[]>` | `copy()` | Creates a new copy of this `RandomAccessVectorValues`.
    `int` | `docID()` | Returns the following: `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
    `Bits` | `getAcceptOrds​(Bits acceptDocs)` | Returns the `Bits` representing live documents.
    `int` | `nextDoc()` | Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set. NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    `byte[]` | `vectorValue()` | Return the vector value for the current document ID.

    - ### Methods inherited from class org.apache.lucene.codecs.lucene95.OffHeapByteVectorValues

      `dimension, load, size, vectorValue`

    - ### Methods inherited from class org.apache.lucene.index.ByteVectorValues

      `cost`

    - ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

      `all, empty, range, slowAdvance`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface org.apache.lucene.util.hnsw.RandomAccessVectorValues

      `ordToDoc`

- - ### Constructor Detail

    - #### DenseOffHeapVectorValues

          public DenseOffHeapVectorValues​(int dimension,
                                          int size,
                                          IndexInput slice,
                                          int byteSize)

  - ### Method Detail

    - #### vectorValue

          public byte[] vectorValue()
                             throws IOException

      Description copied from class: `ByteVectorValues`
      Return the vector value for the current document ID. It is illegal to call this method when the iterator is not positioned: before advancing, or after failing to advance. The returned array may be shared across calls, re-used, and modified as the iterator advances.
      Specified by:
        `vectorValue` in class `ByteVectorValues`
      Returns:
        the vector value
      Throws:
        `IOException`

    - #### docID

          public int docID()

      Description copied from class: `DocIdSetIterator`
      Returns the following:
      - `-1` if `DocIdSetIterator.nextDoc()` or `DocIdSetIterator.advance(int)` were not called yet.
      - `DocIdSetIterator.NO_MORE_DOCS` if the iterator has exhausted.
      - Otherwise it should return the doc ID it is currently on.
      Specified by:
        `docID` in class `DocIdSetIterator`

    - #### nextDoc

          public int nextDoc()
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
      NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
      Specified by:
        `nextDoc` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### advance

          public int advance​(int target)
                      throws IOException

      Description copied from class: `DocIdSetIterator`
      Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

      The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

      When `target > current` it behaves as if written:

           int advance(int target) {
             int doc;
             while ((doc = nextDoc()) < target) {
             }
             return doc;
           }

      Some implementations are considerably more efficient than that.

      NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

      Specified by:
        `advance` in class `DocIdSetIterator`
      Throws:
        `IOException`

    - #### copy

          public RandomAccessVectorValues<byte[]> copy()
                                                throws IOException

      Description copied from interface: `RandomAccessVectorValues`
      Creates a new copy of this `RandomAccessVectorValues`. This is helpful when you need to access different values at once, to avoid overwriting the underlying float vector returned by `RandomAccessVectorValues.vectorValue(int)`.
      Throws:
        `IOException`

    - #### getAcceptOrds

          public Bits getAcceptOrds​(Bits acceptDocs)

      Description copied from interface: `RandomAccessVectorValues`
      Returns the `Bits` representing live documents. By default, this is an identity function.
      Parameters:
        `acceptDocs` - the accept docs
      Returns:
        the accept docs